<template>
  <!-- Botones editar y dar de baja-->
  <div class="b-box-buttons">
    <el-col :span="4" v-bind:id="uniqueId" class="text-center" style="margin-top: 1rem; width: inherit;">
      <!-- BOTON CORTES -->
      <div v-if="cutRoute" class="style_cut_btn" @click="redirectToCuts($event, item)">
        <img v-if="item.materialWithCuts === true" src="../assets/images/tijera-fondo.svg" style="width: 2.5rem">
        <img v-else src="../assets/images/tijera-vacia.svg" style="width: 2.5rem">
      </div>
      <!-- BOTON EDITAR -->
      <router-link :to="'/'+ editRoute" v-if="editRoute !== ''">
        <img v-on:click="edit" src="../assets/images/edit.svg" style="margin-right:10px; width: 2.5rem">
      </router-link>
      <!-- BOTON CAMBIAR DE ESTADO -->
      <img class="pointer"  @click="returnButtonModal = true" v-on:click="statusChangeObj(item)" v-if="item.status" src="../assets/images/candado-open.svg" v-bind:data-state="item.status" style="width: 2.5rem">
      <img class="pointer"  v-else v-on:click="statusChangeActive(item)" src="../assets/images/candado-close.svg" v-bind:data-state="item.status" style="width: 2.5rem">
    </el-col>

    <app-modal :show-dialog.sync="returnButtonModal" v-if="returnButtonModal"  nameClass="dialog-orange" :rutImg="require(`../assets/images/confused.svg`)" sizeImg="80px" textBold="" typeBtn1="primary"
      :parrafo="parrafoModal" classBtn1="border-orange" btn1="DAR DE BAJA" btn2="CANCELAR"  @btnEvent="changeStatus" v-on:eventBtn="returnButtonModal = false">
    </app-modal>

    <app-modal :show-dialog.sync="materialWithoutSupport" v-if="materialWithoutSupport" 
      nameClass="dialog-orange" :rutImg="require(`../assets/images/confused.svg`)" sizeImg="80px" 
      :parrafo="materialWithoutSupportText">
    </app-modal>
  </div>
</template>

<script>

import AppModal from '@/components/AppModal.vue'
import {HTTP} from '@/main.js'

export default {
    name: 'app-card-buttons',
    components: {
      'app-modal': AppModal
    },
    props: ['item', 'uniqueId', 'cutRoute', 'editRoute', 'textModal', 'routeCut'],
    data () {

      return {
        returnButtonModal: false,
        statusChangeMaterial: {},
        parrafoModal: 'Si das de baja a este ' + this.textModal + ' ya no podrás programarlo.<br>¿Seguro que quieres continuar?',
        materialWithoutSupport: false,
        materialWithoutSupportText: ''
      }
    },
    methods: {
      edit($event, item) {
        this.$emit('editEvent', $event, item)
      },
      statusChangeObj(item) {
        this.statusChangeMaterial = item
      },
      statusChangeActive(item) {
        this.statusChangeMaterial = item
        this.changeStatus()
      },
      changeStatus(item) {
        this.returnButtonModal = false
        this.$emit('status', item)
      },
      async redirectToCuts($event, material) {
        let data = await this.isHaveDateInSupport(material)
        if(!material.stringMaterialType || material.stringMaterialType == '') {
          this.materialWithoutSupportText = `El material <strong>${material.listTitle}</strong> está incompleto no tiene definido su <strong>**Tipo de Material**</strong>. </br> Por favor, completarlo para continuar.`
          this.materialWithoutSupport = true
        } else {
          if(data){
          // si existe redirige a cuts
          this.edit($event, this.item)
          this.$router.push({ name: 'cut' })
          } else {
            // si es undefined no redirigir, mostrar modal
            this.materialWithoutSupportText = `El soporte del material <strong>${material.listTitle}</strong> está incompleto. </br> Por favor, completarlo para continuar.`
            this.materialWithoutSupport = true
          }
        }
      },
      async isHaveDateInSupport(material) {
        const {contractCode, numChapters, codMaterial, listTitle, stringMaterialType, supportObj, infoSupport} = material
        let conditional = stringMaterialType ? stringMaterialType.toLowerCase() : ''
       
        if(conditional === 'enlatado') {
          if(contractCode && codMaterial) {
            let data = await this.getInfoContract(contractCode, codMaterial)
            return data
          }
        } else {
          let haveSupport
          /*Con capítulos*/
          if(numChapters && numChapters.length > 0) {
            if(conditional === 'fusión gourmet' || conditional === 'producción nacional') {
              haveSupport = 'Have support'
            }
            else {
              const {infoByChapter} = numChapters[0]
              let arrOfCompleteSupport = []
              let capsWithSupport = []
              infoByChapter.map((e) => {
                const {typeStorage, storage} = e
                if(typeStorage && typeStorage !== null && typeStorage !== '' && storage && storage !== null && storage !== '') {
                  capsWithSupport.push(e)
                }
              })
              capsWithSupport.map((e) => {
                let validate
                if(conditional === 'afiliación-televisa' || conditional === "afiliación/televisa"){
                  e.typeStorage && e.typeStorage !== null && e.typeStorage !== undefined && e.storage && e.storage !== null && e.storage !== undefined ? capsWithSupport.push(e) : null
                } else {
                  e.shippingMode && e.shippingMode !== null && e.shippingMode !== undefined && e.support && e.support !== null && e.support !== undefined ? capsWithSupport.push(e) : null
                   capsWithSupport.push(e)
                }
              })
              if(capsWithSupport.length > 0){
                haveSupport = 'Have support with caps'
              }
            }
          } else {
            /*Sin capítulos*/
            /* SOPORTE DE MATERIAL AFILIADO*/
            if(conditional === 'afiliación-televisa' || conditional === "afiliación/televisa"){
              if(infoSupport && infoSupport[0]) {
                const {storages, supportMaterial} = infoSupport[0]
                supportMaterial.map((e) => {
                  if(storages !== '' && e.typeStorage !== '') {
                    haveSupport = 'Have support'
                  }
                })
              }
            }
            else {
              /* SOPORTE DE MATERIAL NACIONAL*/
              haveSupport = 'Have support'
            }
          }
          return haveSupport
        }
      },
      async getInfoContract(contractCode, codMaterial) {
        let {data} = await HTTP.get(`contracts/typeOfFilter/contractCode/word/${contractCode}`)
        const {contracts} =  data
        if(contracts[0] && contracts[0].admittedMaterials) {
          const information = contracts[0].admittedMaterials.filter((e)=> e.codMaterial == codMaterial)[0]
          if(information) {
            /* OBTIENE SOPORTE DEL MATERIAL ENLATADO */
            const {numChapters, material, infoSupport} = information
            let haveSupport
            if(numChapters.length > 0) {
              /* CON CAPITULOS */
              const {infoByChapter} = numChapters[0]
              let data = []
              await infoByChapter.map((e) => {
                const {storages, supportMaterial} = e
                const {codeDisk, typeStorage} = supportMaterial && supportMaterial.length > 0 ? supportMaterial[0] : []
                if(storages && storages !== '' && typeStorage && typeStorage !== ''){
                  data.push({codMaterial: material,
                    storages: e.storages,
                    supportMaterial: e.supportMaterial})
                }
              })
              data.map((e) => {
                if(e.storages && e.supportMaterial) {
                  haveSupport = 'Have support with caps'
                } else {
                  haveSupport = ''
                }
              })
              console.log({haveSupport, data})
              return haveSupport
            } else {
              /* SIN CAPITULOS */
              if(infoSupport && infoSupport.arrivalDate) {
                const {storages, supportMaterial} = infoSupport
                supportMaterial.map((e) => {
                  if(storages !== '' && e.typeStorage !== '') {
                    haveSupport = 'Have support'
                  }
                })
              } 
              return haveSupport
            }
          }
        }
      },
    },
}
</script>

<style scope>
  .style_cut_btn {
    cursor: pointer;
    display: inline-block;
    margin-right: 10px; 
  }
</style>